// Programming techniques
// Lecture 5 
// - User-defined libraries
// - Debugging
// Transformation of coordinates
// -----------------------------

#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
#include "common_functions.cpp"

using namespace std;

//  Data input (coordinates)
int inp_coords(double c1[], double c2[], int nmax)
{
    int n=0;
    // Define input stream
    ifstream coord("koryfes.txt", ios::in);
    if (! coord) {                               // Check validity of stream
        cerr<<"\n* Error opening input file *\n";
        exit (1); }
    else {                                       // Stream OK, proceed with input
        while ((! coord.eof()) && (n<nmax)) {    // Read until end-of-file OR maximum points
            coord>>c1[n]>>c2[n];
            n++; }          
        coord.close();                           // Disconnect & close file
        }                       
    return n;    
}             

//  Data output (transformed X,Y coordinates)
void out_coords(double x[], double y[], int n)
{
    int k;
    // Define output stream
    ofstream transf("new_koryfes.txt", ios::out);
    if (! transf) {                              // Check validity of stream
        cerr<<"\n* Error opening output file *\n";
        exit (1); }
    else {                                       // Stream OK, proceed with output
        transf<<fixed<<setprecision(3);          // Write output data
        for (k=0;k<n;k++) 
            transf<<setw(10)<<x[k]<<setw(10)<<y[k]<<endl;
        transf.close();                          // Disconnect & close file
        }                       
}             

int main()
{
    double x[100], y[100], nx[100], ny[100], r[100], ag[100], a[100];
    double sx=0., sy=0., xk, yk, b, w;
    int k,n;
    
    n=inp_coords(r,ag,100);
    for (k=0;k<n;k++) {
         polar2ortho(r[k],ag[k],x[k],y[k]);
         sx=sx+x[k];
         sy=sy+y[k];  }
    xk=sx/n;
    yk=sy/n;
    for (k=0;k<n;k++) {
         nx[k]=x[k]-xk;
         ny[k]=y[k]-yk; }    
    ortho2polar(nx[0],ny[0],r[0],b);
    w=b-0.5*pi;
    for (k=0;k<n;k++) 
         rotate_vector2D(nx[k],ny[k],w);    
    out_coords(nx,ny,n);
    
    system("pause");
    return 0;
}

